function q = ClusteringHein(dir, file, K, maxLoop, nbConstraint,...
    propagation2, propagation3, connectedPairs, activeClustering)
EPSILON = 1e-6;
NB_KNN = 5;
data = csvread([dir '/' file 'Points.csv']);
clusters_gt = csvread([dir '/' file 'GT.csv']);
N = size(data,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Création du graphe k-NN symétrique
[index,distance] = knnsearch(data,data,NB_KNN+1);
sigma2 = mean(std(distance,0,2)).^2;
tmp = zeros(N,N);
for j=1:N
    for k=1:NB_KNN
        if (index(j,k)~=j)
            tmp(j,index(j,k)) = 0.25+0.5*exp(-(distance(j,k)^2)/(2*sigma2));
            tmp(index(j,k),j) = tmp(j,index(j,k));
        end
    end
end
W = sparse(tmp);
D = sum(W,2);
mlen = 0; clen = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ML = sparse(N,N);
CL = sparse(N,N);
x = zeros(maxLoop,1);
q = ones(maxLoop,1);
rts = getRandTriSup(N);
for loop=1:maxLoop
    disp('Loop:');
    disp(loop);

     [tmp1,tmp2,tmp3] = find(ML);
     ml=[tmp1,tmp2];
     [tmp1,tmp2,tmp3] = find(CL);
     cl=[tmp1,tmp2];
        if (activeClustering)
            for i=mlen+1:size(ml,1)
                W(ml(i,1),ml(i,2)) = 1; W(ml(i,2),ml(i,1)) = 1;
            end    
            for i=clen+1:size(cl,1)
                W(cl(i,1),cl(i,2)) = 0; W(cl(i,2),cl(i,1)) = 0;
            end
            D = sum(W,2);
            assert(sum(diag(W))==0,'Wrong usage. Graph contains self loops. W has to have zero diagonal.');	
            if (sum(ones(N,1)==(D~=0))~=N)
                for i=1:N
                    if (D(i,1)==0)
                        if (i==1)
                            j=2;
                        else
                            j=i-1;
                        end
                        D(i,1) = EPSILON;
                        W(i,j) = EPSILON;
                        W(j,i) = EPSILON;
                    end
                end
            end
            tic;
            [cut, clusters, viols] = cosc(W, D, K, [], []);
            toc;
            mlen = size(ml,1);
            clen = size(cl,1);
        else
            tic;
            [cut, clusters, viols] = cosc(W, D, K, ml, cl);
            toc;
        end

    q(loop) = adjrand(clusters+1,clusters_gt+1);
    if loop>1
        x(loop) = x(loop-1) + nbConstraint;
    end
    if (rts(2,1)>size(rts,2))
        break;
    end
    if loop<maxLoop
        
        for i=1:nbConstraint
            [sl,rts] = getOneRandomConstraint(ML,CL, rts);
            if (rts(2,1)>size(rts,2))
                break;
            end
            tic;
            [ML,CL] = supervise(sl,clusters_gt,ML,CL,propagation2,propagation3*K);
            toc;
        end
        
    end
end

function randts = getRandTriSup(n)
randp = randperm(n*n);
randindex = [floor(randp/n);mod(randp,n)]+1;
trisup = randindex(1,:)<randindex(2,:);
randts = [randindex(1,trisup);randindex(2,trisup)];
