function [sl,rts] = getOneRandomConstraint(ML,CL, rts)
% Get one random constraints not already supervised.
%
% Input:
%   a:     n x n matrix, where n is the number of data points. It is the
%          supervised status matrix
%   rts:   2 x n(n-1)/2 matrix, where colums are the indexes of all
%          coefficient of matrix tri sup of size n (in random order)
%
% Output:
%   sl:    nbc x 2, the selected pairs
%   a:     the modified supervised status matrix
%   rts:   the modified indexes matrix
% 
if (rts(1,1)==0)
    idx = rts(2,1);
else
    idx = 1;
end
while(true)
    row = rts(1,idx);
    col = rts(2,idx);
    if ((ML(row,col)==0)&&(CL(row,col)==0))
        break;
    end
    idx = idx + 1;
    if (idx>size(rts,2))
        break;
    end
end
rts(1,1) = 0;
rts(2,1) = idx + 1;
sl = [row,col];
% disp([row,col,a(row,col)]);
% a(row,col) = 3;
% a(col,row) = 3;
% a(1,1) = a(1,1) - 1;
